<template>
  <div class="app-container shipping-sea">

    <!-- 搜索工作栏 -->
    <el-form :model="queryParams" ref="queryForm" size="small" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item label="运输方式" prop="transportType">
        <el-select v-model="queryParams.transportType" placeholder="请选择运输方式" clearable size="small">
          <el-option v-for="dict in transportTypes" :key="dict.value" :label="dict.label" :value="dict.value" />
        </el-select>
      </el-form-item>

      <el-form-item label="自编号" prop="selfNo">
        <el-input v-model="queryParams.selfNo" placeholder="请输入自编号" clearable @keyup.enter.native="handleQuery" />
      </el-form-item>
      <el-form-item label="柜号" prop="cubNo">
        <el-input v-model="queryParams.cubNo" placeholder="请输入柜号" clearable @keyup.enter.native="handleQuery" />
      </el-form-item>
      <el-form-item label="柜型" prop="cabinetId">
        <el-select v-model="queryParams.cabinetId" placeholder="请选择柜型">
          <el-option v-for="item in cabinetList" :label="item.name" :value="item.name" :key="item.id"></el-option>
        </el-select>
      </el-form-item>

      <el-form-item label="始发地" prop="startWarehouseId">
        <el-select v-model="queryParams.startWarehouseId" placeholder="请选择始发地">
          <el-option v-for="item in exportWarehouseList" :label="item.titleZh" :value="item.id" :key="item.id"></el-option>
        </el-select>
      </el-form-item>

      <el-form-item label="目的地" prop="destWarehouseId">
        <el-select v-model="queryParams.destWarehouseId" placeholder="请选择目的地">
          <el-option v-for="item in importWarehouseList" :label="item.titleZh" :value="item.id" :key="item.id"></el-option>
        </el-select>
      </el-form-item>

      <el-form-item label="" prop="date">
        <el-select v-model="queryParams.dateType" placeholder="请选择时间类型" clearable size="small">
          <el-option v-for="item in dateTypes" :key="item.value" :label="item.label" :value="item.value" />
        </el-select>
      </el-form-item>

      <el-form-item label="">
        <el-date-picker v-model="queryParams.dateRangeCreateTime" style="width: 240px" value-format="yyyy-MM-dd HH:mm:ss" type="datetimerange" range-separator="-" start-placeholder="开始日期" end-placeholder="结束日期" />
      </el-form-item>

      <el-form-item label="状态" prop="boxStatus">
        <el-select v-model="queryParams.boxStatus" placeholder="请选择状态" clearable size="small">
          <el-option v-for="dict in this.getDictDatas(DICT_TYPE.BOX_SHIPMENT_STATUS)" :key="dict.value" :label="dict.label" :value="dict.value" />
        </el-select>
      </el-form-item>

      <el-form-item label="国家">
        <el-select v-model="queryParams.countryId" placeholder="请选择国家">
          <el-option v-for="item in countryList" :key="item.id" :label="item.titleZh" :value="item.id">
          </el-option>
        </el-select>
      </el-form-item>

      <el-form-item>
        <el-button type="primary" icon="el-icon-search" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <!-- 操作工具栏 -->
    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button type="primary" plain icon="el-icon-plus" size="mini" @click="handleAdd" v-hasPermi="['shipment:box:create']">出货安排
        </el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button type="warning" plain icon="el-icon-download" size="mini" @click="handleExport" :loading="exportLoading" v-hasPermi="['shipment:box:export']">导出
        </el-button>
      </el-col>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <!-- 列表 -->
    <el-table v-loading="loading" :data="list">
      <el-table-column label="自编号" align="center" prop="selfNo">
        <template slot-scope="scope">
          <a href="javascript:void(0)" @click="handleCommand(scope.row, 'detail')">{{ scope.row.selfNo }}</a>
        </template>
      </el-table-column>
      <el-table-column label="柜号" align="center" prop="cubNo" />
      <el-table-column label="柜型" align="center" prop="cabinetId">
        <template slot-scope="scope">
          <span>{{ getCabinetName(scope.row.cabinetId) }}</span>
        </template>
      </el-table-column>
      <el-table-column label="运输方式" align="center" prop="transportType">
        <template slot-scope="scope">
          <dict-tag :type="DICT_TYPE.ECW_TRANSPORT_TYPE" :value="scope.row.transportType" />
        </template>
      </el-table-column>

      <el-table-column label="方数（预装/已装）" align="center" prop="">
        <template slot-scope="{row}">
          {{row.boxStatistics.volume}}/{{row.boxStatistics.loadVolume}}
        </template>
      </el-table-column>
      <el-table-column label="重量（预装/已装）" align="center" prop="weight">
        <template slot-scope="{row}">
          {{row.boxStatistics.weight}}/{{row.boxStatistics.loadWeight}}
        </template>
      </el-table-column>

      <el-table-column label="状态" align="center" prop="shipmentStatusText" />

      <el-table-column label="日期" align="center" prop="createTime" width="180">
        <template slot-scope="scope">
          <span>{{ new Date(scope.row.createTime).format('yyyy-MM-dd hh:mm:ss') }}</span>
        </template>
      </el-table-column>
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width" width="200px">
        <template slot-scope="scope">
          <el-dropdown trigger="click" @command="(command)=>handleCommand(scope.row, command)" style="marginRight:10px;">
            <el-button type="primary">
              操作<i class="el-icon-arrow-down el-icon--right"></i>
            </el-button>
            <el-dropdown-menu slot="dropdown">
              <el-dropdown-item command="edit">编辑</el-dropdown-item>
              <el-dropdown-item command="sea">操作-海运</el-dropdown-item>
              <el-dropdown-item command="error">异常登记</el-dropdown-item>
              <el-dropdown-item command="cost">费用登记</el-dropdown-item>
              <el-dropdown-item command="delete">删除</el-dropdown-item>
              <el-dropdown-item v-if="scope.row.ldStatus==47" command="editLadingBill">编辑提货单</el-dropdown-item>
            </el-dropdown-menu>
          </el-dropdown>
          <el-dropdown trigger="click">
            <el-button type="primary">
              下载<i class="el-icon-arrow-down el-icon--right"></i>
            </el-button>
            <el-dropdown-menu slot="dropdown">
              <el-dropdown-item command="">预装单</el-dropdown-item>
              <el-dropdown-item command="">已装单</el-dropdown-item>
              <el-dropdown-item command="">应收汇总表</el-dropdown-item>
              <el-dropdown-item command="">agent list</el-dropdown-item>
              <el-dropdown-item command="">son cap</el-dropdown-item>
              <el-dropdown-item command="">提货单</el-dropdown-item>
              <el-dropdown-item command="">提单Copy</el-dropdown-item>
            </el-dropdown-menu>
          </el-dropdown>
        </template>
      </el-table-column>
    </el-table>
    <!-- 分页组件 -->
    <pagination v-show="total > 0" :total="total" :page.sync="queryParams.page" :limit.sync="queryParams.pageSize" @pagination="getList" @current-change="pageChange" />

    <!-- 对话框(添加 / 修改) -->
    <el-dialog :title="dialogCfg.title" :visible.sync="dialogCfg.open" :width="dialogCfg.width" :fullscreen="dialogCfg.fullscreen" append-to-body class="shippingSea-dialog">
      <template v-if="dialogCfg.dialogType === 'edit' || dialogCfg.dialogType === 'add'">
        <editForm v-if="dialogCfg.open" @closeDialog="closeDialog" :shipmentObj="currRow" :warehouseList="warehouseList" :transportTypes="transportTypes" :cabinetList="cabinetList" />
      </template>
      <template v-if="dialogCfg.dialogType === 'cost'">
        <costForm v-if="dialogCfg.open" @closeDialog="closeDialog" :shipmentObj="currRow" />
      </template>
      <template v-if="dialogCfg.dialogType === 'error'">
        <regError v-if="dialogCfg.open" @closeDialog="closeDialog" :shipmentObj="currRow" />
      </template>
      <template v-if="dialogCfg.dialogType === 'editLadingBill'">
        <ladingBill v-if="dialogCfg.open" @closeDialog="closeDialog" :shipmentObj="currRow" :getCabinetName="getCabinetName" />
      </template>
    </el-dialog>
  </div>
</template>

<script>
import { deletebox, getbox, getboxPage, exportboxExcel } from "@/api/ecw/box";
import { getCabinetPage } from "@/api/ecw/cabinet";
import { getWarehouseList } from "@/api/ecw/warehouse";
import { getListTree } from "@/api/ecw/region";
import costForm from "./costForm.vue";
import regError from "./regError.vue";
import editForm from "./editForm.vue";
import ladingBill from "./ladingBill/index.vue";

export default {
  name: "indexSea",
  components: {
    costForm,
    regError,
    editForm,
    ladingBill,
  },
  data() {
    return {
      dateTypes: [
        { value: "1", label: "预装时间" },
        { value: "2", label: "装柜时间" },
        { value: "3", label: "起运时间" },
        { value: "4", label: "到港时间" },
        { value: "5", label: "清关时间" },
        { value: "6", label: "提货时间" },
      ],
      // 遮罩层
      loading: true,
      // 导出遮罩层
      exportLoading: false,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 出货列表
      list: [],
      // 弹出层标题
      // 弹出类型
      dialogCfg: {
        title: "",
        dialogType: "",
        width: "600px",
        // 是否显示弹出层
        open: false,
        fullscreen: false,
      },
      // 当前行
      currRow: {},
      dateRangeCreateTime: [],
      // 查询参数
      queryParams: {
        page: 1,
        pageSize: 10,
      },
      cabinetList: [],
      warehouseList: [],
      transportTypes: [],
      //国家信息列表
      countryList: [],
    };
  },
  computed: {
    exportWarehouseList() {
      return this.warehouseList.filter(
        (item) => item.tradeType == "2" || item.type == "3"
      );
    },
    importWarehouseList() {
      return this.warehouseList.filter(
        (item) => item.tradeType == "1" || item.type == "3"
      );
    },
    getCabinetName() {
      return (cabinetId) => {
        for (let index in this.cabinetList) {
          let cabinetItem = this.cabinetList[index];
          if (cabinetItem.id == cabinetId) {
            return cabinetItem.name;
          }
        }
      };
    },
  },
  created() {
    this.transportTypes = this.getDictDatas(
      this.DICT_TYPE.ECW_TRANSPORT_TYPE
    ).filter((item) => item.value == "1" || item.value == "2");
    getWarehouseList().then((res) => (this.warehouseList = res.data));
    getCabinetPage(null).then((response) => {
      this.cabinetList = response.data.list;
    });
    this.getList();
    this.getCountryList();
  },
  methods: {
    /* 国家 */
    getCountryList() {
      getListTree({ treeType: 1 }).then((response) => {
        this.countryList = response.data;
      });
    },
    /** 查询列表 */
    getList() {
      this.loading = true;
      // 处理查询参数
      let params = { ...this.queryParams };
      params.transportTypeList = ["1", "2"];
      this.addBeginAndEndTime(params, this.dateRangeCreateTime, "createTime");
      // 执行查询
      getboxPage(params).then((response) => {
        this.list = response.data.list;
        this.total = response.data.total;
        this.loading = false;
      });
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.page = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.dateRangeCreateTime = [];
      this.resetForm("queryForm");
      this.handleQuery();
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.$set(this.dialogCfg, "title", "添加出货");
      this.$set(this.dialogCfg, "dialogType", "add");
      this.$set(this.dialogCfg, "width", "600px");
      this.$set(this.dialogCfg, "fullscreen", false);
      this.$set(this.dialogCfg, "open", true);
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      const id = row.id;
      getbox(id).then((response) => {
        this.currRow = response.data;
        this.$set(this.dialogCfg, "title", "修改出货");
        this.$set(this.dialogCfg, "dialogType", "edit");
        this.$set(this.dialogCfg, "width", "600px");
        this.$set(this.dialogCfg, "open", true);
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      this.$modal
        .confirm(`是否确认删除出货编号为 ${row.selfNo} 的数据项?`)
        .then(function () {
          return deletebox(row.id);
        })
        .then(() => {
          this.getList();
          this.$modal.msgSuccess("删除成功");
        })
        .catch(() => {});
    },
    /** 导出按钮操作 */
    handleExport() {
      // 处理查询参数
      let params = { ...this.queryParams };
      params.page = undefined;
      params.pageSize = undefined;
      this.addBeginAndEndTime(params, this.dateRangeCreateTime, "createTime");
      // 执行导出
      this.$modal
        .confirm("是否确认导出所有出货数据项?")
        .then(() => {
          this.exportLoading = true;
          return exportboxExcel(params);
        })
        .then((response) => {
          this.$download.excel(response, "${table.classComment}.xls");
          this.exportLoading = false;
        })
        .catch(() => {});
    },
    /* 关闭弹窗 */
    closeDialog(type) {
      this.$set(this.dialogCfg, "open", false);
      if (type === "add" || type === "edit") {
        this.getList();
      }
    },
    /** 查看按钮操作 */
    handleCommand(row, command) {
      this.$set(this.dialogCfg, "fullscreen", false);

      switch (command) {
        case "sea":
          this.$router.push("/boxSea/shippingSea/" + row.id);
          break;

        case "edit":
          this.handleUpdate(row);
          break;

        case "delete":
          this.handleDelete(row);
          break;

        case "detail":
          this.$router.push("/boxSea/query/" + row.id);
          break;

        case "editLadingBill":
          const cabinetLabel = this.getCabinetName(row.cabinetId);
          const title = `查看提单 ${row.selfNo ?? ""} 柜号：${
            row.cubNo ?? ""
          } 柜型：${cabinetLabel}`;
          this.$set(this.dialogCfg, "title", title);
          this.$set(this.dialogCfg, "fullscreen", true);
          break;

        case "cost":
          this.$set(this.dialogCfg, "title", "费用登记");
          break;

        case "error":
          this.$set(this.dialogCfg, "title", "异常登记");
          break;
      }

      if (["editLadingBill", "cost", "error"].includes(command)) {
        this.currRow = row;
        this.$set(this.dialogCfg, "dialogType", command);
        this.$set(this.dialogCfg, "width", "600px");
        this.$set(this.dialogCfg, "open", true);
      }
    },
    /* 分页 */
    pageChange(page) {
      this.pageParam.page = page;
      this.getList();
    },
  },
};
</script>
